/* binding_list.cpp - helper functions for binding wxItemContainer to
    wxPg::List_binding

    Copyright (C) 2008, 2009 Aurimas Černius

    This file is part of wxPostgres.

    wxPostgres is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    wxPostgres is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with wxPostgres.  If not, see <http://www.gnu.org/licenses/>.
*/

#include<wxPg/binding/binding_list.h>
#include<wx/arrstr.h>

namespace{

void
update_ctrl_str(wxItemContainer *c, const wxString &field,
                wxPg::Result_data_provider *data){
    int current = data->current();
    int total_rows = data->rows();
    int cursor = 0;
    data->current(cursor);
    wxArrayString values;
    values.Alloc(total_rows);
    int col_idx = data->col_idx(field);
    while(cursor < total_rows){
        values.Add(data->get_str(col_idx));
        data->current(++cursor);
    }

    data->current(current);
    c->Clear();
    c->Append(values);
}

}


void
wxPg::bind_list_str(wxPg::List_binding *binding, wxItemContainer *c,
                    const wxString &field){
    binding->bind(c, field, update_ctrl_str);
}
