/* list_binding.cpp - binding wxItemContainer to contain the values of some
    field in wxPg::Result_data

    Copyright (C) 2008, 2009 Aurimas Černius

    This file is part of wxPostgres.

    wxPostgres is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    wxPostgres is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with wxPostgres.  If not, see <http://www.gnu.org/licenses/>.
*/

#include<wxPg/binding/list_binding.h>


wxPg::List_binding::List_binding()
    :data_(NULL)
{}


wxPg::List_binding::List_binding(wxPg::Result_data_provider *data)
    :data_(data)
{}


void
wxPg::List_binding::data(wxPg::Result_data_provider *data){
    this->data_ = data;
}


wxPg::Result_data_provider*
wxPg::List_binding::data(){
    return this->data_;
}


void
wxPg::List_binding::bind(wxItemContainer *c, wxString field, append_ctrl_f f){
    this->ctrl_bindings_[c] = std::make_pair(field, f);
}


void
wxPg::List_binding::unbind(wxItemContainer *c){
    this->ctrl_bindings_.erase(c);
}


void
wxPg::List_binding::unbind(wxWindow *c){
    this->ctrl_bindings_.erase(reinterpret_cast<wxItemContainer*>(c));
}


void
wxPg::List_binding::update_UI(){
    if(!this->data_)
        return;

    for(std::map<wxItemContainer*, ctrl_binding>::iterator
            it = this->ctrl_bindings_.begin();
            it != this->ctrl_bindings_.end(); ++it)
        it->second.second(it->first, it->second.first, this->data_);
}
