/* row_binding.cpp - binding wxWindow to display value of some
    field in wxPg::Data_row

    Copyright (C) 2008, 2009 Aurimas Černius

    This file is part of wxPostgres.

    wxPostgres is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    wxPostgres is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with wxPostgres.  If not, see <http://www.gnu.org/licenses/>.
*/

#include<wxPg/binding/row_binding.h>


wxPg::Row_binding::Row_binding()
    :data_(NULL)
{}


wxPg::Row_binding::Row_binding(wxPg::Data_row_provider *data)
    :data_(data)
{}


wxPg::Data_row_provider*
wxPg::Row_binding::data(){
    return this->data_;
}


void
wxPg::Row_binding::data(wxPg::Data_row_provider *data){
    this->data_ = data;
}


void
wxPg::Row_binding::bind(wxWindow *w, wxString field, upd_ctrl_f f){
    this->ctrl_bindings_[w] = std::make_pair(field, f);
}


void
wxPg::Row_binding::unbind(wxWindow *w){
    this->ctrl_bindings_.erase(w);
}


void
wxPg::Row_binding::update_UI(){
    if(!this->data_)
        return;
    for(std::map<wxWindow*, ctrl_binding>::iterator
            it = this->ctrl_bindings_.begin();
            it != this->ctrl_bindings_.end(); ++it)
        it->second.second(it->first, it->second.first, this->data_);
}
