/* ui_manager.cpp - implementation for UI_manager class.

    Copyright (C) 2008 Aurimas Černius

    This file is part of wxPostgres.

    wxPostgres is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    wxPostgres is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with wxPostgres.  If not, see <http://www.gnu.org/licenses/>.
*/

#include<wxPg/binding/ui_manager.h>
#include<algorithm>
#include<functional>


wxPg::UI_manager::UI_manager(){}


wxPg::UI_manager::~UI_manager(){}


void
wxPg::UI_manager::update_UI(){
    std::for_each(this->updaters_.begin(), this->updaters_.end(),
                  std::mem_fun(&wxPg::UI_updater::update_UI));
}


void
wxPg::UI_manager::add(wxPg::UI_updater *updater){
    if(!updater || updater == this) //don't add NULL and self.
        return;

    this->updaters_.insert(updater);
}


void
wxPg::UI_manager::remove(wxPg::UI_updater *updater){
    this->updaters_.erase(updater);
}


void
wxPg::UI_manager::clear(){
    this->updaters_.clear();
}
