/* result_data.cpp - implementation of class wxPg::Result_data for accessing
    data from result of SQL query

    Copyright (C) 2008, 2009 Aurimas Černius

    This file is part of wxPostgres.

    wxPostgres is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    wxPostgres is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with wxPostgres.  If not, see <http://www.gnu.org/licenses/>.
*/

#include<wxPg/db/result_data.h>

wxPg::Result_data::Result_data(wxPg::Database *db)
: wxPg::Data_row(db){}


wxPg::Result_data::~Result_data(){}


int
wxPg::Result_data::rows(){
    PGresult *res = this->result();
    if(!res)
        return 0;

    return PQntuples(res);
}


bool
wxPg::Result_data::current(int new_curr){
    int rows = this->rows();
    if(new_curr < 0 || new_curr >= rows)
        return false;

    this->current_ = new_curr;
    return true;
}


int
wxPg::Result_data::current()const{
    return this->current_;
}
