/* type.cpp - functions for getting type information for database data types

    Copyright (C) 2008, 2009 Aurimas Černius

    This file is part of wxPostgres.

    wxPostgres is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    wxPostgres is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with wxPostgres.  If not, see <http://www.gnu.org/licenses/>.
*/

#include<wxPg/utils/type.h>

int
wxPg::oid_to_type_simple(int oid){
    switch(oid){
    case 21:   //int2
    case 23:   //int4
        return wxPg::TYPE_INT;
    case 700:  //float4
    case 701:  //float8
        return wxPg::TYPE_FLOAT;
    case 18:   //char
    case 19:   //name
    case 1043: //varchar
        return wxPg::TYPE_STRING;
    case 1082: //date
        return wxPg::TYPE_DATE;
    case 1083: //time
        return wxPg::TYPE_TIME;
    case 1114: //timestamp
        return wxPg::TYPE_TIMESTAMP;
    case 16:   //boolean
        return wxPg::TYPE_BOOL;
    default:
        return wxPg::TYPE_UNKNOWN;
    }
}
