/* binding_ctrl.h - abstract data binding class wxPg::Binding

    Copyright (C) 2008, 2009 Aurimas Černius

    This file is part of wxPostgres.

    wxPostgres is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    wxPostgres is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with wxPostgres.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __BINDING_H
#define __BINDING_H

#include "wxPg/conf.h"
#include "wxPg/binding/ui_updater.h"
#include<wx/control.h>


namespace wxPg{

/** Abstract base class for data binding. */
class wxPG_DECLSPEC
Binding : public UI_updater{
public:
    /** Constructor. */
    Binding(){}

    /** Destructor. */
    virtual
    ~Binding(){}

    /** Remove wxWindow from control of Binding object.
        @param w - widget to be removed.
    */
    virtual void
    unbind(wxWindow *w) = 0;
private:
    Binding(const Binding&){}
    Binding &operator=(const Binding&){return *this;}
};

}

#endif
