/* binding_list.h - helper functions for binding wxItemContainer to
    wxPg::List_binding

    Copyright (C) 2008, 2009 Aurimas Černius

    This file is part of wxPostgres.

    wxPostgres is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    wxPostgres is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with wxPostgres.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __BINDING_LIST_H
#define __BINDING_LIST_H

#include "wxPg/conf.h"
#include "wxPg/binding/list_binding.h"
#include<wx/ctrlsub.h>

namespace wxPg{

/** Bind c to binding to contain values of column field.
    @param binding - List_binding to bind c.
    @param c - container to bind.
    @param field - field (database column), to bind to c.
*/
wxPG_DECLSPEC void
bind_list_str(List_binding *binding, wxItemContainer *c,
              const wxString &field);

}

#endif
