/* ui_updater.h - abstract UI updater class wxPg::UI_updater

    Copyright (C) 2008, 2009 Aurimas Černius

    This file is part of wxPostgres.

    wxPostgres is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    wxPostgres is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with wxPostgres.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __UI_UPDATER_H
#define __UI_UPDATER_H

#include "wxPg/conf.h"

namespace wxPg{

/** Abstract base class for changing user interface. */
class wxPG_DECLSPEC
UI_updater{
public:
    UI_updater(){}

    virtual
    ~UI_updater(){}

    /** Update UI. */
    virtual void
    update_UI() = 0;
private:
    UI_updater(const UI_updater&){}
    UI_updater &operator=(const UI_updater&){return *this;}
};

}

#endif
