/* db_client.h - class wxPg::DB_client attaching to wxPg::Database.

    Copyright (C) 2009 Aurimas Černius

    This file is part of wxPostgres.

    wxPostgres is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    wxPostgres is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with wxPostgres.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __DB_CLIENT_H
#define __DB_CLIENT_H

namespace wxPg{

/** Class for attaching to wxPg::Database. */
class wxPG_DECLSPEC
DB_client{
public:
    /** Constructor. */
    DB_client(){}

    /** Destructor. */
    virtual
    ~DB_client(){}

    /** Detach notification from Database.
        This methon is called by wPg::Database, when client is detached
        because of external reasons (Such as database disconnect).
    */
    virtual void
    detach() = 0;
private:
    DB_client(const DB_client&){}                          //copy not allowed
    DB_client &operator=(const DB_client&){return *this;}  //can not assign
};

}

#endif
