/* result_data.h - class wxPg::Result_data for accessing data from
    result of SQL query

    Copyright (C) 2008, 2009 Aurimas Černius

    This file is part of wxPostgres.

    wxPostgres is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    wxPostgres is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with wxPostgres.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __RESULT_DATA_H
#define __RESULT_DATA_H

#include "wxPg/conf.h"
#include "wxPg/db/data_row.h"
#include "wxPg/db/result_data_provider.h"

namespace wxPg{

/** Class, representing result of SQL query. */
class wxPG_DECLSPEC
Result_data : virtual public Data_row, virtual public Result_data_provider{
public:
    /** Creates new object.
        You should not need to create Result_data objects directly.
        @param db - database connection.
    */
    explicit
    Result_data(Database *db);

    /** Destructor. */
    virtual
    ~Result_data();

    //inherited
    virtual int
    rows();

    //inherited
    virtual bool
    current(int idx);

    //inherited
    virtual int
    current()const;
private:
    Result_data(const Result_data&) :Data_row(NULL){}
    Result_data &operator=(const Result_data&){return *this;}
};

}

#endif
